/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Zone class.
 * @constructor
 * Describes a DNS zone.
 * @member {string} [etag] Gets or sets the ETag of the zone that is being
 * updated, as received from a Get operation.
 * 
 * @member {number} [maxNumberOfRecordSets] Gets or sets the maximum number of
 * record sets that can be created in this zone.
 * 
 * @member {number} [numberOfRecordSets] Gets or sets the current number of
 * record sets in this zone.
 * 
 * @member {array} [nameServers] Gets the name servers populated for this
 * zone. This is a read-only property and any attempt to set this value will
 * be ignored.
 * 
 */
function Zone() {
  Zone['super_'].call(this);
}

util.inherits(Zone, models['Resource']);

/**
 * Defines the metadata of Zone
 *
 * @returns {object} metadata of Zone
 *
 */
Zone.prototype.mapper = function () {
  return {
    required: false,
    serializedName: 'Zone',
    type: {
      name: 'Composite',
      className: 'Zone',
      modelProperties: {
        id: {
          required: false,
          readOnly: true,
          serializedName: 'id',
          type: {
            name: 'String'
          }
        },
        name: {
          required: false,
          readOnly: true,
          serializedName: 'name',
          type: {
            name: 'String'
          }
        },
        type: {
          required: false,
          readOnly: true,
          serializedName: 'type',
          type: {
            name: 'String'
          }
        },
        location: {
          required: true,
          serializedName: 'location',
          type: {
            name: 'String'
          }
        },
        tags: {
          required: false,
          serializedName: 'tags',
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        },
        etag: {
          required: false,
          serializedName: 'etag',
          type: {
            name: 'String'
          }
        },
        maxNumberOfRecordSets: {
          required: false,
          serializedName: 'properties.maxNumberOfRecordSets',
          type: {
            name: 'Number'
          }
        },
        numberOfRecordSets: {
          required: false,
          serializedName: 'properties.numberOfRecordSets',
          type: {
            name: 'Number'
          }
        },
        nameServers: {
          required: false,
          readOnly: true,
          serializedName: 'properties.nameServers',
          type: {
            name: 'Sequence',
            element: {
                required: false,
                serializedName: 'StringElementType',
                type: {
                  name: 'String'
                }
            }
          }
        }
      }
    }
  };
};

module.exports = Zone;
